Always run ldconfig even if we don't change ld.so.conf.
[wine] / tools / wineinstall
1 #!/bin/bash
2 # WINE Installation script
3 # Can do almost everything from compiling to configuring...
4 #
5 # Copyright 1999 Ove Kåven
6 #
7 # This library is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU Lesser General Public
9 # License as published by the Free Software Foundation; either
10 # version 2.1 of the License, or (at your option) any later version.
11 #
12 # This library is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
15 # Lesser General Public License for more details.
16 #
17 # You should have received a copy of the GNU Lesser General Public
18 # License along with this library; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
20 #
21 # History:
22 # Mar 31 1999 - Ove Kåven
23 #  First version
24 # Dec 9 1999 - Ove Kåven
25 #  require Xpm
26 # Feb 25 2000 - Ove Kåven
27 #  auto-add /usr/local/lib to /etc/ld.so.conf
28 # Mar 2 2000 - Ove Kåven
29 #  source rather than grep config.cache
30 #  use sourced config.cache to start ldconfig
31 #  reconfigure if config.cache doesn't exist
32 # Mar 30 2000 - Ove Kåven
33 #  autoconfigure no-windows installs
34 #  do not install registry on real-windows installs
35 #  some support for binary package installs
36 #  set and tell user about LD_LIBRARY_PATH if necessary
37 #  set EXTRA_LD_LIBRARY_PATH in wine.conf
38 # Apr 9 2000 - Ove Kåven
39 #  make root's registry global (system-default)
40 # May 9 2000 - Ove Kåven
41 #  use ttydrv when running regapi, so we don't have to run from X
42 #  change debugger path in registry
43 # Oct 29 2000 - Ove Kåven
44 #  added --enable-opengl to default confargs
45 #  added conf_question, conf_yesno_answer, and conf_string_answer functions
46 #  added DEFCAT variable
47 # (later that day...)
48 #  added conf_reset_question function
49 #  added file existence checks to the registry copying
50 #  fixed problem with no-windows directory creation
51 #  some text reformatting from Eric Maryniak
52 # Jan 5 2000 - Chris Morgan
53 #  use default config file in /documentation/samples/config
54 #  replace .winerc with ~/.wine/config in printed text
55 #  added user question to convert .winerc file(if exists) or use the default
56 #    config file
57 #  add conf_question to allow root to install a local config file and
58 #    registry
59 # Jan 12 2000 - Chris Morgan
60 #  distinguish between creating local and global config files
61 #  display a message about the status of global config files
62 #  misc cleanups and reordering of questions
63 #  added check to see if wine is installed when we are running as a normal
64 #    user and print a message if wine cannot be found
65 # Feb 16 2002 - Adam D. Moss
66 #  Use config.status instead of config.cache to check whether we're
67 #    configured/compiled and to recreate the configuration
68 # Feb 20 2002 - Adam D. Moss
69 #  Partially revert previous changes, force configure to write an
70 #    old-style config.cache
71 # Mar 27 2002 - Chris Morgan
72 #  prevent the user from running wineinstall as root
73 #  add script commands so we su root for 'make install' and other commands
74 #    that require root access
75 #  add text to tell the user we need to run stuff as root so they don't 
76 #    think we are trying to pull something funny
77 # Apr 14 2002 - Dustin Navea
78 #  Fix sed command when finding real-windows registry so it actually 
79 #   accesses a file (~/.wine/config) instead of null ($CONF?!)
80 #  Added search for clean-install (not upgrade) Win2k registry
81 #  (next day, after some sleep)
82 #  Fix sed string when finding real-windows registry to actually find 
83 #   windows partition name in [Drive C] section
84 #  it should now almost always find the windows partition and real-windows 
85 #  registry (if not, let me know)
86
87 #--- defaults (change these if you are a packager)
88 CONFARGS="--enable-opengl"    # configure args, e.g. --prefix=/usr --sysconfdir=/etc
89 prefix=/usr/local             # installation prefix
90 sysconfdir=$prefix/etc        # where wine.conf and global registry is supposed to be
91 bindir=$prefix/bin            # where winelib apps will be (or is) installed
92 libdir=$prefix/lib            # where libwine.so will be (or is) installed
93 exdir=documentation/samples   # where the example system.ini resides
94 GCONF=$sysconfdir/wine.conf   # default path of the wine.conf global config file
95 LCONF=~/.wine/config          # default path of the local config file
96 BINDIST=no                    # whether called from a binary package config script
97 DOGLOBALCONF=auto             # whether to autogenerate wine.conf
98 DOLOCALCONF=auto              # whether to autogenerate localconf
99 DOWCHK=auto                   # whether to autoconfigure existing-windows installation
100 DOWINE=auto                   # whether to autoconfigure no-windows installation
101 DOREG=auto                    # whether to install default registry
102 SYSREG=yes                    # whether to make root's registry global (system-default)
103 CONVCONF=no                   # whether we are converting an existing .winerc or not
104
105 # "make install" still installs the dlls into $libdir, but this may change in the future
106 # (DLLPATH should point to them if/when they are not in standard ld.so paths)
107 DLLPATH=$libdir/wine          # default path of the dll .so files (except libwine.so)
108
109 # having the Wine debugger launched automatically will be a plus for us
110 DEBUGGER=$bindir/winedbg      # the (installed) path of winedbg
111 HDEBUGGER=debugger/winedbg    # the (non-installed) path of winedbg
112
113 # this is only for existing-windows installs
114 WINECONF=tools/wineconf       # the path of wineconf perl script
115
116 # this is only for no-windows installs
117 WINEINI=$exdir/config         # the path of default wine config file (also used by wineconf)
118 WININI=/dev/null              # the path of default win.ini
119 SYSTEMINI=$exdir/system.ini   # the path of default system.ini
120 REGAPI=programs/regapi/regapi # the path of regapi winelib application
121 DEFREG=winedefault.reg        # the path of the registry file to be fed to regapi
122 # CROOT=/var/wine             # the path of the fake Drive C (asks user if not set)
123 DEFCAT=cat                    # program to cat $DEFREG with (some packages need zcat)
124 #--- end of defaults
125
126 # temporary files used by the installer
127 TMPCONF=/tmp/wineinstall.conf
128 TMPREG=/tmp/wineinstall.reg
129
130 # functions
131
132 function std_sleep {
133   sleep 1
134 }
135
136 function conf_question {
137   # parameters: $1 = importance, $2 = question-id, $3+ = message lines
138   # the first two parameters can be used by e.g. debconf in debian packages
139   # but here we just print the message
140   shift 2
141   echo
142   local LINE="$1"
143   while shift
144   do {
145     echo "$LINE"
146     LINE="$1"
147   }
148   done
149 }
150
151 function conf_reset_question {
152   # parameters: $1 = question-id
153   # this is used to flush any cached answers and "already-displayed" flags
154   shift # dummy command
155 }
156
157 function conf_yesno_answer {
158   unset ANSWER
159   while [ "$ANSWER" != 'yes' ] && [ "$ANSWER" != 'no' ]
160   do {
161     echo -n "$1"
162     read ANSWER
163   }
164   done
165 }
166
167 function conf_string_answer {
168   echo -n "$1"
169   read ANSWER
170 }
171
172 function create_windows_directories {
173   for tdir in "$CROOT/windows" "$CROOT/windows/system" \
174               "$CROOT/windows/Start Menu" "$CROOT/windows/Start Menu/Programs" \
175               "$CROOT/Common Files" "$CROOT/Program Files" \
176               "$CROOT/windows/Profiles" "$CROOT/windows/Profiles/Administrator"
177   do [ -d "$tdir" ] || mkdir "$tdir"
178   done
179   [ -f "$CROOT/windows/win.ini" ]    || cp "$WININI"    "$CROOT/windows/win.ini"
180   [ -f "$CROOT/windows/system.ini" ] || cp "$SYSTEMINI" "$CROOT/windows/system.ini"
181 }
182
183 # startup...
184
185 echo "WINE Installer v0.72"
186 echo
187
188 if [ "$BINDIST" = 'no' ]
189 then {
190
191 if ! [ -f configure ]
192 then {
193   echo "You're running this from the wrong directory."
194   echo "Change to the Wine source's main directory and try again."
195   exit 1
196 }
197 fi
198
199 if [ `whoami` == 'root' ]
200 then {
201   echo "You are running wineinstall as root, this is not advisable. Please rerun as a user."
202   echo "Aborting."
203   exit 1
204 }
205 fi
206
207 # check whether RPM installed, and if it is, remove any old wine rpm.
208 hash rpm &>/dev/null
209 RET=$?
210 if [ $RET -eq 0 ]; then
211   if [ -n "`rpm -qi wine 2>/dev/null|grep "^Name"`" ]; then
212     echo "Warning: Old Wine RPM install detected. Do you want to remove it first?"
213     conf_yesno_answer "(yes/no) "
214     if [ "$ANSWER" = 'yes' ]; then
215       echo "We need to remove the rpm as root, please enter your root password"
216       echo
217       echo Starting wine rpm removal...
218       su -c "rpm -e wine; RET=$?"
219       if [ $RET -eq 0 ]; then
220         echo Done.
221       else
222         echo "FAILED. Probably you aren't installing as root."
223         echo "Expect problems (library conflicts with existing install etc.)."
224       fi
225     else
226       echo "Sorry, I won't install Wine when an rpm version is still installed."
227       echo "(Wine support suffered from way too many conflicts between RPM"
228       echo "and source installs)"
229       echo "Have a nice day !"
230       exit 1
231     fi 
232   fi
233 fi
234
235 # check whether wine binary still available
236 if [ -n "`which wine 2>/dev/null|grep '/wine'`" ]; then
237   echo "Warning !! wine binary (still) found, which may indicate"
238   echo "a (conflicting) previous installation."
239   echo "You might want to abort and uninstall Wine first."
240   std_sleep
241 fi
242
243 # run the configure script, if necessary
244
245 if [ -f config.cache ] && [ -f Makefile ] && [ Makefile -nt configure ]
246 then {
247   echo
248   echo "I see that WINE has already been configured, so I'll skip that."
249   std_sleep
250   # load configure results
251   . ./config.cache
252 }
253 else {
254   echo "Running configure..."
255   echo
256   if ! ./configure -C $CONFARGS
257   then {
258     echo
259     echo "Configure failed, aborting install."
260     rm -f config.cache
261     exit 1
262   }
263   fi
264   # load configure results
265   . ./config.cache
266   # make sure X was found
267   eval "$ac_cv_have_x"
268   if [ "$have_x" != "yes" ]
269   then {
270     echo "Install the X development headers and try again."
271     rm -f config.cache
272     exit 1
273   }
274   fi
275 }
276 fi
277
278 # now do the compilation and install, we need to always do this because we 
279 # don't want the 'make install' command we might run to run 'make' as root
280 if [ `whoami` != 'root' ]
281 then {
282   # ask the user if they want to build and install wine
283   echo
284   echo "We need to install wine as root user, do you want us to build wine,"
285   echo "'su root' and install Wine?  Enter 'no' to continue without installing"
286   conf_yesno_answer "(yes/no) "
287
288   if [ "$ANSWER" = "yes" ]
289   then {
290     # start out with the basic command
291     sucommand="make install"
292
293     # if the user doesn't have $libdir in their ld.so.conf add this
294     # to our sucommand string
295     if [ -f /etc/ld.so.conf ]
296     then
297       if [ ! grep -qs "$libdir" /etc/ld.so.conf ]
298       then {
299         echo
300         echo "$libdir doesn't exist in your /etc/ld.so.conf, it will be added"
301         echo "when we perform the install..."
302         sucommand="$sucommand;echo $libdir>>/etc/ld.so.conf"
303       }
304       fi
305       # run ldconfig always just in case some updated files dont get linked
306       sucommand="$sucommand;$ac_cv_path_LDCONFIG"
307     fi
308
309     echo
310
311     echo "Compiling WINE. Grab a lunch or two, rent a video, or whatever,"
312     echo "in the meantime..."
313     echo
314     std_sleep
315
316     # try to just make wine, if this fails 'make depend' and try to remake
317     if ! { make; }
318     then {
319       if ! { make depend && make; }
320       then {
321         echo
322         echo "Compilation failed, aborting install."
323         exit 1
324       }
325       fi
326     }
327     fi
328     echo
329
330     echo "Performing 'make install' as root to install binaries, enter root password"
331
332     std_sleep
333
334     if ! su root -c "$sucommand"
335     then {
336       echo
337       echo "Either you entered an incorrect password or we failed to run"
338       echo "'$sucommand' correctly."
339       echo "If you didn't enter an incorrect password then please report this"
340       echo "error to wine-devel@winehq.com."
341       echo
342       echo "Installation failed, aborting."
343       exit 1
344     }
345     fi
346
347     echo
348
349     # see if wine is installed on the users system, if not prompt them
350     # and then exit
351     if [ ! `which wine` ]
352     then
353       echo "Could not find wine on your system.  Run wineinstall as root to install wine"
354       echo "before re-running wineinstall as a user."
355       echo
356       echo "Exiting wineinstall"
357       exit 1;
358     fi
359   }
360   else {
361     # user didn't want to install wine so tell them about running from the
362     # current directory and set some stuff up for them
363
364     # setup to run from current directory
365     DLLPATH="$PWD/dlls"
366     if [ -z "$LD_LIBRARY_PATH" ]
367     then LD_LIBRARY_PATH="$PWD:$DLLPATH"
368     else LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PWD:$DLLPATH"
369     fi
370     export LD_LIBRARY_PATH
371     DEBUGGER="$PWD/$HDEBUGGER"
372     echo
373     echo "NOTE! To run Wine without installing, you must set the environment variable"
374     echo "LD_LIBRARY_PATH to $PWD:$DLLPATH"
375     echo "in your logon scripts."
376     echo
377   }
378   fi
379 }
380 else {
381   echo "You are running wineinstall as root, this is not advisable. Please rerun as a user."
382   echo "Aborting."
383   exit 1
384 }
385 fi # [ `whoami` != 'root' ]
386
387 }
388 fi # BINDIST
389
390 # now check whether we should generate wine.conf
391 if [ -z "$DOGLOBALCONF" ]
392 then
393   DOGLOBALCONF=auto
394 fi
395
396 if [ "$DOGLOBALCONF" = 'auto' ]
397 then {
398   # see if we already have a system wine.conf
399   if [ ! -f $GCONF ] && [ `whoami` = 'root' ]
400   then
401     DOGLOBALCONF=no
402     echo "Creation of a global config file is not supported in wineinstall at this"
403     echo "time.  When the configuration architecture is cleaned up this functionality"
404     echo "will be restored to wineinstall."
405     echo
406   fi
407 }
408 fi
409
410 if [ "$DOLOCALCONF" = 'auto' ]
411 then {
412   # see if the user is root, if so, explicitly ask them if they want a
413   # local config file
414   if [ `whoami` = 'root' ]
415   then
416     echo "You are running as root.  Do you want a local config file,"
417     echo "file, ~/.wine/config, created?"
418     conf_yesno_answer "(yes/no) "
419     DOLOCALCONF="$ANSWER"
420   else
421     # if the user has an existing config file ask them if they want us to
422     # overwrite it, otherwise just ask them if they want to create one
423     if [ -f "$LCONF" ]
424     then
425       echo "Found existing $LCONF, do you want to overwrite this"
426       echo "existing Wine configuration file?"
427       conf_yesno_answer "(yes/no) "
428       DOLOCALCONF="$ANSWER"
429       echo
430     else {
431       echo "Create local config file ~/.wine/config?"
432       conf_yesno_answer "(yes/no) "
433       DOLOCALCONF="$ANSWER"
434       echo
435       if [ "$ANSWER" = 'no' ]
436       then
437         conf_question high need_root \
438           "Aborting install. Try again as root to generate a system wine.conf."
439         exit 1
440       fi
441     }
442     fi
443   fi
444 }
445 fi
446
447 # generate $TMPCONF from existing windows install, if any
448 if [ "$DOLOCALCONF" = 'yes' ]
449 then {
450   if [ "$DOWCHK" = 'yes' ] || [ "$DOWCHK" = 'auto' ]
451   then {
452     echo -n "Searching for an existing Windows installation..."
453     if ! $WINECONF -inifile "$WINEINI" > $TMPCONF 2>/dev/null
454     then {
455       rm -f $TMPCONF $TMPREG > /dev/null
456
457       echo " not found. (no matching /etc/fstab mount entry found)"
458       conf_question low do_without_windows \
459        "Windows was not found on your system, so I assume you want" \
460        "a Wine-only installation. Am I correct?"
461       conf_yesno_answer "(yes/no) "
462       if [ "$ANSWER" = 'no' ]
463       then {
464         conf_question high windows_not_found \
465          "Aborting install. Make sure your Windows partition is mounted and try again," \
466          "or create $LCONF manually by copying from $WINEINI and adapting the drive paths."
467         exit 1
468       }
469       fi
470       DOWINE=yes
471     }
472     else {
473       echo " found."
474
475       conf_reset_question windows_found
476       conf_question low windows_found \
477        "Created $LCONF using your existing Windows installation." \
478        "You probably want to review the file, though."
479       DOWINE=no
480     }
481     fi
482   }
483   elif [ "$DOWINE" = 'auto' ]
484   then DOWINE=yes
485   fi
486 }
487 elif [ "$DOWINE" = 'auto' ]
488 then 
489   DOWINE=no
490 fi
491
492 # setup a no-windows installation, if necessary
493 if [ "$DOWINE" = 'yes' ]
494 then {
495   # set an appropriate DCROOT
496   if [ `whoami` != 'root' ]
497   then DCROOT=~/c
498   else DCROOT=/c
499   fi
500
501   if [ -f ~/.winerc ]
502   then {
503     conf_question medium convert_config \
504      "I found the old version Wine config file, .winerc, in your " \
505      "home directory.  I can convert this to the new format or use the" \
506      "new default Wine config file. Convert?"
507     conf_yesno_answer "(yes/no) "
508     if [ "$ANSWER" = 'yes' ]
509     then {
510       WINEINI=~/.winerc
511       CONVCONF=yes
512     }
513     fi
514   }
515   else {
516
517     conf_question low drivec_path \
518      "Configuring Wine without Windows." \
519      "Some fake Windows directories must be created, to hold any .ini files, DLLs," \
520      "start menu entries, and other things your applications may need to install." \
521      "Where would you like your fake C drive to be placed?"
522     while [ -z "$CROOT" ]
523     do {
524       conf_string_answer "(default is $DCROOT) "
525       [ -z "$ANSWER" ] && ANSWER="$DCROOT"
526       if ! [ -d "$ANSWER" ]
527       then {
528         if mkdir -p "$ANSWER"
529         then CROOT="$ANSWER"
530         else
531           echo "Directory $ANSWER can't be created !"
532           conf_reset_question drivec_path
533         fi
534       }
535       else CROOT="$ANSWER"
536       fi
537     }
538     done
539     echo "Configuring Wine for a no-windows install in $CROOT..."
540   
541     create_windows_directories
542   }
543   fi
544
545   # create $LCONF using the default config file $WINEINI  
546   if [ "$DOLOCALCONF" = 'yes' ] && [ "$CONVCONF" = 'no' ]
547   then {
548     sed "s|\"Path\" = \"/c\"\$|\"Path\" = \"${CROOT}\"|" $WINEINI > $TMPCONF
549     conf_reset_question default_config
550     conf_question low default_config \
551      "Created $LCONF using default Wine configuration." \
552      "You probably want to review the file, though."
553   }
554   fi
555
556   # now we really should install the registry
557   if [ "$DOREG" = 'auto' ]
558   then DOREG=yes
559   fi
560 }
561 fi
562 echo
563
564 #install the local config file $LCONF
565 if [ "$DOLOCALCONF" = 'yes' ]
566 then
567   if [ ! -w ~/.wine ]
568   then
569     mkdir ~/.wine
570   fi
571
572   if [ "$CONVCONF" = 'no' ]
573   then
574     cp $TMPCONF $LCONF > /dev/null
575   fi
576 else
577   DOREG=no
578 fi      
579
580 #install the global config file $GCONF
581 if [ "$DOGLOBALCONF" = 'yes' ]
582 then
583   if [ ! -f $sysconfdir ]
584   then
585     mkdir -p $sysconfdir
586   fi
587
588   cp $TMPCONF $GCONF > /dev/null
589 fi
590
591 # check whether we need to install default registry
592 # (not to be done if windows registry exists)
593 if [ "$DOREG" = 'auto' ]
594 then {
595   CROOT=`sed -n '/^\[Drive C\]$/,/^\[.*\]$/ s/^\"Path\" = \"\(.*\)\"/\1/p' $LCONF`
596   echo "Checking for real Windows registry..."
597   if [ -f "$CROOT/windows/system.dat" ]
598   then DOREG=no
599   elif [ -f "$CROOT/windows/system32/config/system" ]
600   then DOREG=no
601   elif [ -f "$CROOT/WINNT/system32/config/system" ]
602   then DOREG=no 
603   else DOREG=yes
604   fi
605   if [ "$DOREG" = 'yes' ]
606   then echo "Not found, default Wine registry will be installed."
607   else echo "Windows registry found, will not install default Wine registry."
608   fi
609   echo
610 }
611 fi
612
613 # install default registry entries
614 if [ "$DOREG" = 'yes' ]
615 then {
616   if [ "$BINDIST" = 'no' ]
617   then {
618     echo "Compiling regapi..."
619     (cd programs/regapi; make)
620     echo
621   }
622   fi
623   echo "Preparing to install default Wine registry entries..."
624
625   # edit config files so we don't have to run regapi under X
626   if [ "$CONVCONF" = 'yes' ]
627   then
628     mv $WINEINI $WINEINI.new
629     sed "s/GraphicsDriver=.*/GraphicsDriver=ttydrv/" $WINEINI.new > $WINEINI
630   else
631     mv $LCONF $LCONF.new
632     sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"ttydrv\"/" $LCONF.new > $LCONF
633   fi
634
635   # create a temporary wineinstall.reg with fixed debugger path
636   $DEFCAT $DEFREG | sed "s|debugger/winedbg|${DEBUGGER}|" > $TMPREG
637
638   echo "Installing default Wine registry entries..."
639   echo
640   if ! $REGAPI setValue < $TMPREG > /dev/null
641   then {
642     rm -f $TMPREG
643     echo "Registry install failed."
644     conf_reset_question regapi_error
645     conf_question high regapi_error
646     exit 1
647   }
648   else {
649     # if we are converting from a .winerc file, running regapi once
650     # will ONLY convert .winerc -> ~/.wine/config, it will not import the
651     # registry data.  so if we are converting we need to run regapi twice
652     if [ "$CONVCONF" = 'yes' ]
653     then
654       if ! $REGAPI setValue < $TMPREG > /dev/null
655       then
656         rm -f $TMPREG
657         echo "Registry install failed."
658         conf_reset_question regapi_error
659         conf_question high regapi_error
660         exit 1
661       else
662         echo
663         echo "Registry entries successfully installed."
664       fi
665     else
666       echo
667       echo "Registry entries successfully installed."
668     fi
669   }
670   fi
671   rm -f $TMPREG
672   if [ "$SYSREG" = 'auto' ]
673   then SYSREG=yes
674   fi
675
676   # if we converted we need to change the graphics driver back and
677   # restore the original .winerc file
678   if [ "$CONVCONF" = 'yes' ]
679   then
680      mv $WINEINI.new $WINEINI
681   fi
682
683   sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"x11drv\"/" $LCONF > $LCONF.new
684   mv $LCONF.new $LCONF
685 }
686 fi
687
688 # make root's registry global, if desired
689 if [ `whoami` = 'root' ] && [ "$DOREG" = 'yes' ] && [ "$SYSREG" = 'yes' ]
690 then {
691   [ -d ~/.wine ] || mkdir ~/.wine
692   if ! [ -f $sysconfdir/wine.userreg ]
693   then {
694     echo "Linking root's user registry hive to the global registry..."
695     [ -f ~/.wine/wine.userreg ] && cp ~/.wine/wine.userreg $sysconfdir/wine.userreg
696     ln -sf $sysconfdir/wine.userreg ~/.wine/wine.userreg
697   }
698   fi
699   if ! [ -f $sysconfdir/wine.systemreg ]
700   then {
701     echo "Linking root's system registry hive to the global registry..."
702     [ -f ~/.wine/system.reg ] && cp ~/.wine/system.reg $sysconfdir/wine.systemreg
703     ln -sf $sysconfdir/wine.systemreg ~/.wine/system.reg
704   }
705   fi
706 }
707 fi
708
709 # cleanup any temporary files that may remain
710 if [ -f $TMPCONF ]
711 then rm -f $TMPCONF
712 fi
713 if [ -f $TMPREG ]
714 then rm -f $TMPREG
715 fi
716
717
718 # it's a wrap
719 echo
720 echo "Installation complete for now. Good luck (this is still alpha software)."
721 echo "If you have problems with WINE, please read the documentation first,"
722 echo "as many kinds of potential problems are explained there."
723
724 exit 0